#ifndef REGISTRY_H
#define REGISTRY_H

#pragma once

#include "stdafx.h"

typedef struct _RegModuleInformation
{
	ULONGLONG ullEResourceOffset;
	ULONG dwTimeStamp;
	ULONG dwChecksum;
} RegModuleInformation;

extern "C"
{
	NTSTATUS InitializeEnvironment(PUNICODE_STRING pusRegPath);
	NTSTATUS QueryRegistryParams(PUNICODE_STRING pusRegPath, RegModuleInformation* prmiWin32k);
	NTSTATUS FixupPtrOffsets(RegModuleInformation* prmiWin32k);
	NTSTATUS MapModule(PUNICODE_STRING pusModulePath, PVOID* pAddress, PSIZE_T pViewSize);
	NTSTATUS UnmapModule(PVOID pAddress);
}

#ifdef ALLOC_PRAGMA
#pragma alloc_text(INIT, InitializeEnvironment, QueryRegistryParams)
#pragma alloc_text(INIT, FixupPtrOffsets, MapModule)
#pragma alloc_text(INIT, UnmapModule)
#endif

#endif
