#include "stdafx.h"
#include "List.h"
#include "DesktopHeapInfo.h"

// list of DesktopHeapInfoEntry structures
SINGLE_LIST_ENTRY g_DesktopList;

void EmptyDeskList()
{
	PAGED_CODE();
	PSINGLE_LIST_ENTRY pDeskEntry;
	while((pDeskEntry = PopEntryList(&g_DesktopList)) != NULL)
	{
		delete pDeskEntry;
	}
}

// the original version saves the count in a global variable
// but there's really no reason to
ULONG CountDeskListEntries()
{
	PAGED_CODE();
	ULONG dwNumDesktops = 0;
	PSINGLE_LIST_ENTRY pList = g_DesktopList.Next;
	while(pList)
	{
		++dwNumDesktops;
		pList = pList->Next;
	}
	return dwNumDesktops;
}

void CopyDesktopListToBuffer(DesktopHeapInfo* pDeskHeapOut)
{
	PAGED_CODE();
	PSINGLE_LIST_ENTRY pDeskEntry = g_DesktopList.Next;
	while(pDeskEntry)
	{
		DesktopHeapInfoEntry* pDeskHeapInfoEntry = reinterpret_cast<DesktopHeapInfoEntry*>(pDeskEntry);
		memcpy(pDeskHeapOut, &(pDeskHeapInfoEntry->dhi), sizeof(*pDeskHeapOut));
		++pDeskHeapOut;
		pDeskEntry = pDeskEntry->Next;
	}
}
